/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;

import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.ConexionService;
import com.rjconsultores.ventaboletos.vo.conexion.ConexionVO;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConexion;

/**
 * 
 * @author Gleimar
 */
@Controller("busquedaConexionController")
@Scope("prototype")
public class BusquedaConexionController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private ConexionService conexionService;
	private MyListbox conexionesList;
	private Combobox cmbParadaOrigem;
	private Combobox cmbParadaDestino;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		conexionesList.setData(conexionService.buscarConexionesValidas());

		conexionesList.setItemRenderer(new RenderConexion());
		conexionesList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				ConexionVO conexionVO = (ConexionVO) conexionesList.getSelected();
				verConexionCtrl(conexionVO.getConexionCtrlId());
			}
		});
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verConexionCtrl(Long conexionCtrlId) {
		Map args = new HashMap();
		args.put("conexionCtrlId", conexionCtrlId);
		args.put("conexionesList", conexionesList);

		openWindow("/gui/esquema_operacional/editarConexion.zul",
				Labels.getLabel("editarConexionController.window.title"), args, MODAL);
	}

	// TODO Geneciones de Conexiones Desabilitado
	// public void onClick$btnGenerarConexiones(Event ev) throws InterruptedException {
	// int resp = Messagebox.show(
	// Labels.getLabel("busquedaConexionController.msgGerarCombincoes"),
	// Labels.getLabel("busquedaConexionController.window.title"), Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
	//
	// if (resp == Messagebox.YES) {
	// conexionService.gerarConexiones();
	//
	// Messagebox.show(
	// Labels.getLabel("busquedaConexionController.msgCombincoesGeradas"),
	// Labels.getLabel("busquedaConexionController.window.title"),
	// Messagebox.OK, Messagebox.INFORMATION);
	// }
	// }

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	private void refreshLista() {
		Integer origemId = cmbParadaOrigem.getSelectedItem() != null ? ((Parada) cmbParadaOrigem.getSelectedItem().getValue()).getParadaId() : null;
		Integer destinoId = cmbParadaDestino.getSelectedItem() != null ? ((Parada) cmbParadaDestino.getSelectedItem().getValue()).getParadaId() : null;

		if (origemId == null && destinoId == null)
			conexionesList.setData(conexionService.buscarConexionesValidas());
		else
			conexionesList.setData(conexionService.buscarConexiones(origemId, destinoId));

	}

	public void onClick$btnNovo(Event ev) {
		verConexionCtrl(null);
	}
}
